[![vue-email](/public/repo-banner.png)](https://vuemail.net)

<div align="center">

[![npm version][npm-version-src]][npm-version-href]
[![npm downloads][npm-downloads-src]][npm-downloads-href]
[![JSDocs][jsdocs-src]][jsdocs-href]
[![License][license-src]][license-href]

</div>

# 💌 vue-email

Simple way to build email templates in vue.

- [✨ &nbsp;Release Notes](https://github.com/vue-email/vue-email/releases)
- [📖 &nbsp;Read the documentation](https://vuemail.net)
- [💚 &nbsp;Nuxt Module](https://nuxt.com/modules/vue-email)

> [!IMPORTANT]
> Experimental and under heavy development. APIs are subject to change.

## Features

- 🧩 Build email templates with Vue components
- 🛤️ [SSR support](https://vuemail.net/ssr/compiler), preview/send emails both on server and client, now with support for deno and bun.
- 🌍 [i18n support](https://vuemail.net/plugins/i18n)
- 📨 [Integrates with many email providers](https://vuemail.net/integrations/nodemailer)
- 🧪 Tested against popular email clients
- 🎨 [Supports Tailwind CSS](https://vuemail.net/components/tailwind)
- 🚚 First-class support for Nuxt 3
- ✨ Written in TypeScript

## Ecosystem

| Package                     | Version                                                                                            |
| --------------------------- | :------------------------------------------------------------------------------------------------- |
| [Vue-Email](https://github.com/vue-email/vue-email)       | ![tres version](https://img.shields.io/npm/v/vue-email/latest.svg?label=%20&colorB=1fa669) |
| [Nuxt](https://github.com/vue-email/nuxt) | ![nuxt version](https://img.shields.io/npm/v/@vue-email/nuxt/latest.svg?label=%20&color=4f4f4f&logo=nuxt.js) |
[SSR Compiler](https://github.com/vue-email/compiler) | ![cientos version](https://img.shields.io/npm/v/@vue-email/compiler/latest.svg?label=%20&colorB=1fa669) |
| [CLI](https://github.com/vue-email/cli)       | ![tres version](https://img.shields.io/npm/v/@vue-email/cli/latest.svg?label=%20&colorB=1fa669) |

## Installation

```bash
# Using npm
npm install vue-email

# Using yarn
yarn add vue-email

# Using pnpm
pnpm add vue-email
```

## 💻 Development

1. Clone this repository
2. Enable [Corepack](https://github.com/nodejs/corepack) using `corepack enable`
3. Install dependencies using `pnpm install`

## 🛟 Support
If you like our work, please feel to free to [support us](https://github.com/sponsors/vue-email)!

## License

[MIT](./LICENSE) License © 2023-PRESENT [Vue Email](https://vuemail.net/)

[npm-version-src]: https://img.shields.io/npm/v/vue-email/latest?style=flat&colorA=080f12&colorB=1fa669
[npm-version-href]: https://npmjs.com/package/vue-email
[npm-downloads-src]: https://img.shields.io/npm/dm/vue-email?style=flat&colorA=080f12&colorB=1fa669
[npm-downloads-href]: https://npmjs.com/package/vue-email
[license-src]: https://img.shields.io/github/license/vue-email/vue-email.svg?style=flat&colorA=080f12&colorB=1fa669
[license-href]: https://github.com/vue-email/vue-email/blob/main/LICENSE
[jsdocs-src]: https://img.shields.io/badge/jsdocs-reference-080f12?style=flat&colorA=080f12&colorB=1fa669
[jsdocs-href]: https://www.jsdocs.io/package/vue-email
